active_members/urls.py
from django.urls import path, include
from django.views.generic import ListView, DetailView
from . import views
from .models import Member, SubTeam, Team
from django.contrib.auth.decorators import login_required

urlpatterns = [
    # Nous allons réécrire l'URL de l'accueil
    path('',login_required(ListView.as_view(model=Member,paginate_by=30)), name="home"),
    path('member', login_required(ListView.as_view(model=Member,paginate_by=30)), name='list_member'),
    path('member/<int:pk>', login_required(DetailView.as_view(model=Member)), name='show_member'),
    path('member/edit/<int:pk>', views.MemberUpdate.as_view(), name='edit_member'),
    path('member/add', login_required(views.memberCreate), name='create_member'),
    path('member/sync/<int:pk>', login_required(views.sync_member), name="sync_member"),
    path('member/update_membership/<int:pk>', login_required(views.update_membership), name="update_membership_member"),
    path('subteam/<int:pk>', login_required(DetailView.as_view(model=SubTeam)), name='show_subteam'),
    path('subteam/add_member/<int:pk>', views.add_member_subteam, name='edit_member_subteam'),
    path('subteam/edit/<int:pk>', views.SubTeamUpdate.as_view(), name='edit_subteam'),
    path('subteam/<int:pk_subteam>/delete/<int:pk_member>', views.deleteMemberSubteam, name='delete_member_subteam'),
    path('subteam/<int:pk_subteam>/clean', views.cleanSubteam, name='clean_subteam'),
    path('team', login_required(ListView.as_view(model=Team,)), name='list_team'),
    path('team/<int:pk>', login_required(DetailView.as_view(model=Team)), name='show_team'),
    path('team/edit/<int:pk>', views.TeamUpdate.as_view(), name='edit_team'),
    path('team/<int:pk_team>/clean', views.cleanTeam, name='clean_team'),
]

mapp/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('accounts/', include('django.contrib.auth.urls')),
    path('', include('active_members.urls')),
]

active_members/models.py
# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.db import models
from datetime import date

# Create your models here.
GENRES = [
    ('M', "Homme"),
    ('F', "Femme"),
    ('U', 'Indéfini/Inconnu')
]
TYPE_EQUIPE = [
    ('M', "Manifs"),
    ('A', "Animations"),
    ('S', "Services"),
    ('T', 'Transversal')
]

TYPE_MAILING = [
    ('S', "Sous-Equipe"),
    ('R', "Resps"),
]


class InsaSecurityGroup(models.Model):
    name = models.CharField(verbose_name='Nom du groupe sur AD', blank=False, max_length=255, null=False)

    def __str__(self):
        return self.name


class LedMailing(models.Model):
    mail = models.CharField(verbose_name='Adresse Email de la Mailing', blank=False, max_length=255, null=False)
    type = models.CharField(max_length=1, choices=TYPE_MAILING, default='S')

    def __str__(self):
        return self.mail

    @property
    def cmd_generator(self):
        if (self.type == "S"):
            liste = [];
            mail_list = self.subTeams.members.all()
            for mail in mail_list:
                liste.append(mail.insa_email)
            if (self.subTeams.team.check_resp is True and self.subTeams.check_resp is True):
                liste.append(self.subTeams.team.responsable.insa_email)
            else:
                return "Probleme avec les resp (sous equipe ou equipe g)"
            return liste(set(liste))  # To remove duplicate
        elif (self.type == "R"):
            liste = [];
            sub_list = SubTeam.objects.filter(team=self.team).all()
            for sub in sub_list:
                if (sub.check_resp is True):
                    liste.append(sub.responsable.insa_email)
                else:
                    return "Erreur resp sous equipe"
            if (self.team.check_resp is True):
                liste.append(self.team.responsable.insa_email)
            else:
                return "Erreur resp general"
            return liste(set(liste))  # To remove duplicate


class BdeSecurityGroup(models.Model):
    name = models.CharField(verbose_name='Nom du groupe sur AD', blank=False, max_length=255, null=False)

    def __str__(self):
        return self.name


class Member(models.Model):
    adhesion_id = models.IntegerField(verbose_name='ID sur Adhésion', unique=True, null=True,
                                      blank=True)
    has_valid_membership = models.BooleanField("A la carte VA", null=False, default=False)
    last_name = models.CharField(verbose_name='Nom', blank=False, max_length=255, null=False)
    first_name = models.CharField(verbose_name='Prénom', blank=False, max_length=255, null=False)
    insa_email = models.EmailField(verbose_name='Email INSA', blank=False, max_length=255, null=False, unique=True)
    insa_username = models.CharField(verbose_name='Login INSA', blank=True, max_length=20, null=True)
    office365_email = models.EmailField(verbose_name='Email BdE', blank=True, max_length=255, null=True)
    gender = models.CharField(max_length=1, choices=GENRES, default='U')
    birthdate = models.DateField(verbose_name="Date de naissance", default=date.today, blank=True)
    promo = models.IntegerField(verbose_name='Promo INSA', null=False, blank=False)
    teams = models.ManyToManyField("SubTeam", related_name="members", blank=True)

    def __str__(self):
        return "{0} {1} - Promo {2}".format(self.first_name, self.last_name, self.promo)

    @property
    def is_ma(self):
        return self.teams.filter(team__is_ma=True).all().count() > 0

    @property
    def profil_complete(self):
        if self.insa_username is not None and self.office365_email is not None and self.birthdate is not None and self.has_valid_membership:
            return True
        else:
            return False

    @property
    def age(self):
        delta = date.today() - self.birthdate
        return delta.days // 365


class Team(models.Model):
    name = models.CharField(max_length=255, verbose_name="Nom de l'équipe")
    type = models.CharField(max_length=1, choices=TYPE_EQUIPE, verbose_name="Type d'équipe")
    is_ma = models.BooleanField(verbose_name="Considère le membre comme actif ?", default=True)
    responsable = models.ForeignKey("Member", null=True, on_delete=models.PROTECT, blank=True)
    resp_mailing = models.ForeignKey("LedMailing", null=True, on_delete=models.PROTECT, related_name="team",
                                     blank=True)
    team_insa_group = models.ForeignKey("InsaSecurityGroup", null=True, on_delete=models.PROTECT, related_name="+",
                                        blank=True)
    team_bde_group = models.ForeignKey("BdeSecurityGroup", null=True, on_delete=models.PROTECT, related_name="+",
                                       blank=True)
    responsable_insa_group = models.ForeignKey("InsaSecurityGroup", null=True, on_delete=models.PROTECT,
                                               related_name="+",
                                               blank=True)
    responsable_bde_group = models.ForeignKey("BdeSecurityGroup", null=True, on_delete=models.PROTECT, related_name="+",
                                              blank=True)

    def __str__(self):
        return "{0} ".format(self.name)

    @property
    def nombre(self):
        return Member.objects.filter(teams__in=self.subTeams.all()).distinct().count()

    @property
    def check_resp(self):
        if (self.responsable is not None):
            if (Member.objects.filter(insa_email=self.responsable.insa_email).filter(
                    teams__in=self.subTeams.all()).count() == 1):
                return True
            else:
                return False
        else:
            return False

    @property
    def nombre_sous_equipe(self):
        return self.subTeams.count()

    @property
    def check_all_ok(self):
        check = True
        teams = SubTeam.objects.filter(team=self)
        for team in teams:
            if (not team.check_resp):
                check = False
        if (not self.check_resp):
            check = False
        return check

    @property
    def clean_team(self):
        teams = SubTeam.objects.filter(team=self)
        for team in teams:
            team.clean_team
        self.responsable = None
        self.save()


class SubTeam(models.Model):
    name = models.CharField(max_length=255, verbose_name="Nom de l'équipe")
    responsable = models.ForeignKey(to=Member, null=True, on_delete=models.PROTECT, blank=True, related_name="resp")
    mailing = models.ForeignKey("LedMailing", null=True, on_delete=models.PROTECT, related_name="subTeams",
                                blank=True)
    team = models.ForeignKey("Team", null=False, on_delete=models.PROTECT, related_name="subTeams", blank=False)
    recruit_open = models.BooleanField(default=False)

    def __str__(self):
        return "{0} -  {1}".format(self.team.name, self.name)

    @property
    def nombre(self):
        return self.members.count()

    @property
    def check_resp(self):
        if (self.responsable is not None):
            if (Member.objects.filter(insa_email=self.responsable.insa_email).filter(
                    teams=self).count() == 1):
                return True
            else:
                return False
        else:
            return False

    @property
    def clean_team(self):
        members = Member.objects.filter(teams=self)
        for member in members:
            member.teams.remove(self)
        self.responsable = None
        self.save()

active_members/forms.py
from django import forms
from .models import Member, Team, SubTeam
from django.utils import timezone
from bootstrap_datepicker_plus import DatePickerInput

BIRTH_YEAR_CHOICES = ['']
for i in range(1992, 2005):
    BIRTH_YEAR_CHOICES.append(i)


class MemberCreateForm(forms.ModelForm):
    teams_form = forms.ModelChoiceField(queryset=SubTeam.objects.all())
    class Meta:
        model = Member
        exclude = ('adhesion_id', 'teams')
        widgets = {
            'birthdate': forms.SelectDateWidget(years=BIRTH_YEAR_CHOICES),
        }
        help_texts = {
            'insa_email': ('Doit être unique'),
            'adhesion_id': ('Sera récupéré automatiquement si email insa = email dans adhesion'),
            'first_name': ('Obligatoire'),
            'last_name': ('Obligatoire'),
            'promo': ('Obligatoire'),
        }
        now = timezone.now()
        widgets = {'birthdate': DatePickerInput(format='%d/%m/%Y', options={
            "showClose": False,
            "showClear": False,
            "showTodayButton": False,
            "locale": "fr",
            "minDate": now.isoformat(),
            "defaultDate": now.isoformat(),
        })}


class MemberForm(forms.ModelForm):
    class Meta:
        model = Member
        exclude = ('adhesion_id', 'teams',)
        widgets = {
            'birthdate': forms.SelectDateWidget(years=BIRTH_YEAR_CHOICES),
        }
        help_texts = {
            'insa_email': ('Doit être unique'),
            'adhesion_id': ('Sera récupéré automatiquement si email insa = email dans adhesion'),
            'first_name': ('Obligatoire'),
            'last_name': ('Obligatoire'),
            'promo': ('Obligatoire'),
        }
        now = timezone.now()
        widgets = {'birthdate': DatePickerInput(format='%d/%m/%Y', options={
            "showClose": False,
            "showClear": False,
            "showTodayButton": False,
            "locale": "fr",
            "defaultDate": now.isoformat(),
        })}


class TeamForm(forms.ModelForm):
    class Meta:
        model = Team
        fields = "__all__"
    # def __init__(self, *args, **kwargs):
    #     super(TeamForm, self).__init__(*args, **kwargs)
    #     self.fields['responsable'].queryset = Member.objects.filter(is_ma=True).all()


class SubTeamForm(forms.ModelForm):
    class Meta:
        model = SubTeam
        fields = "__all__"


class AddMemberSubteamForm(forms.Form):
    member = forms.ModelChoiceField(queryset=Member.objects.all(), empty_label=None)

active_members/views.py
from django.shortcuts import render, redirect
from django.views.generic import CreateView, UpdateView
from django.urls import reverse
from .models import Member, SubTeam, Team
from .forms import MemberForm, TeamForm, SubTeamForm, AddMemberSubteamForm, MemberCreateForm
from django.contrib.auth.decorators import login_required
from django.contrib.auth.mixins import LoginRequiredMixin
from django.shortcuts import get_object_or_404
from active_members.adhesion_api import AdhesionAPI
from active_members import utils
from django.http import HttpResponseServerError



def memberCreate(request):
    form = MemberCreateForm(request.POST or None)
    if form.is_valid():
        content = form.save()
        content.teams.add(form.cleaned_data['teams_form'].pk)
        content.save()
        return redirect(reverse('show_member', args=[content.pk]))
    else:
        return render(request, 'active_members/form_new.html', {"form": form})


class MemberUpdate(LoginRequiredMixin, UpdateView):
    model = Member
    template_name = 'active_members/form_basic.html'
    form_class = MemberForm

    def get_success_url(self):
        return reverse('show_member', args=(self.object.pk,))


class TeamUpdate(LoginRequiredMixin, UpdateView):
    model = Team
    template_name = 'active_members/form_basic.html'
    form_class = TeamForm

    def get_success_url(self):
        return reverse('show_team', args=(self.object.pk,))


class SubTeamUpdate(LoginRequiredMixin, UpdateView):
    model = SubTeam
    template_name = 'active_members/form_basic.html'
    form_class = SubTeamForm

    def get_success_url(self):
        return reverse('show_subteam', args=(self.object.pk,))


def sync_member(request, pk):
    member = get_object_or_404(Member, pk=pk)
    if member.office365_email is None:
        print("generate email")
    if member.adhesion_id is None:
        api = AdhesionAPI()
        adhesion_member = api.get_member_email(email=member.insa_email)
        if len(adhesion_member) == 1:
            member.adhesion_id = adhesion_member[0]["id"]
            member.has_valid_membership = adhesion_member[0]["has_valid_membership"]
            member.save()
    return redirect(reverse('show_member', args=[member.pk]))


def update_membership(request, pk):
    member = get_object_or_404(Member, pk=pk)
    if utils.update_adhesion_membership(member):
        return redirect(reverse('show_member', args=[member.pk]))
    else:
        return HttpResponseServerError()



@login_required
def add_member_subteam(request, pk):
    form = AddMemberSubteamForm(request.POST or None)
    team = SubTeam.objects.get(pk=pk)
    form.fields["member"].queryset = Member.objects.exclude(teams=team).all()
    if form.is_valid():
        member = form.cleaned_data['member']
        member.teams.add(team)
        return redirect(reverse('show_subteam', args=(pk,)))
    else:
        return render(request, 'active_members/form_basic.html', {'form': form})


@login_required
def deleteMemberSubteam(request, pk_member, pk_subteam):
    member = Member.objects.get(pk=pk_member)
    subteam = SubTeam.objects.get(pk=pk_subteam)
    member.teams.remove(subteam)
    return redirect(reverse('show_subteam', args=(pk_subteam,)))


@login_required
def cleanSubteam(request, pk_subteam):
    subteam = SubTeam.objects.get(pk=pk_subteam)
    subteam.clean_team
    return redirect(reverse('show_subteam', args=(pk_subteam,)))


@login_required
def cleanTeam(request, pk_team):
    team = Team.objects.get(pk=pk_team)
    team.clean_team
    return redirect(reverse('show_team', args=(pk_team,)))

active_members/templates/active_members/form_basic.html
{% extends "base.html" %}
{% load crispy_forms_tags %}

{% block content %}
<form method="post" action="">
    {% csrf_token %}
    {{ form.media }}
    {{ form|crispy }}
<button class="btn btn-primary" style="width:100%">Enregistrer</button>
</form>
{% endblock %}

active_members/templates/active_members/form_new.html
{% extends "base.html" %}
{% load crispy_forms_tags %}

{% block content %}
<form method="post" action="">
    {% csrf_token %}
    {{ form|crispy }}
<button class="btn btn-primary" style="width:100%">Enregistrer</button>
</form>

<script>
function updateUserInfo(){
    email = $( "#id_first_name" ).val().toLowerCase() + "." + $( "#id_last_name" ).val().toLowerCase() + "@insa-lyon.fr";
    insa_login = $( "#id_first_name" ).val().toLowerCase().charAt(0) + $( "#id_last_name" ).val().toLowerCase();
    $("#id_insa_email").val(email);
    $("#id_insa_username").val(insa_login);
}
$( "#id_last_name" ).blur(updateUserInfo);
$( "#id_first_name" ).blur(updateUserInfo);

</script>
{% endblock %}

active_members/templates/active_members/member_detail.html
{% extends "base.html" %}
{% block content %}
    <div class="row">
        <div class="col">
            <h1 class="">{{ object.first_name }} {{ object.last_name }}</h1>
            <a href="{% url "edit_member" object.pk %}"><button type="button" class="btn btn-warning">Editer le MA</button></a>
            <a href="{% url "sync_member" object.pk %}"><button type="button" class="btn btn-warning">Sync le MA</button></a>
            {% if object.adhesion_id is not None %}
                <a href="{% url "update_membership_member" object.pk %}"><button type="button" class="btn btn-warning">Mettre à jour VA</button></a>
                <button type="button" class="btn btn-success">Acceder au profil Adhésion</button>{% endif %}
            <br>
        </div>
    </div>
  <br>
    <div class="row">
        <div class="col-sm-3">
            <!--left col-->
            <ul class="list-group">
                <li class="list-group-item text-muted" contenteditable="false">Détails</li>
                <li class="list-group-item text-right"><span class="pull-left"><strong class="">Email INSA: </strong></span><br> {{ object.insa_email }}</li>
                <li class="list-group-item text-right"><span class="pull-left"><strong class="">Date de naissance: </strong></span><br> {{ object.birthdate }} ({{ object.age }} an{{ object.age|pluralize }})</li>
                <li class="list-group-item text-right"><span class="pull-left"><strong class="">Sexe: </strong></span> {{ object.gender }}</li>
                <li class="list-group-item text-right"><span class="pull-left"><strong class="">Promo: </strong></span> {{ object.promo }}</li>
                <li class="list-group-item text-right"><span class="pull-left"><strong class="">Login INSA: </strong></span>{{ object.insa_username }}</li>
                <li class="list-group-item text-right"><span class="pull-left"><strong class="">Email BdE: </strong></span><br> {{ object.office365_email }}</li>
                <li class="list-group-item text-right"><span class="pull-left"><strong class="">ID Adhésion: </strong></span> {{ object.adhesion_id }}</li>
            </ul>
        </div>
        <!--/col-3-->
        <div class="col-sm-9" style="" contenteditable="false">
            <h3>Vérifications</h3>
            <div class="table-responsive">
                <table class="table">
                    {% if object.has_valid_membership %}
                        <tr class="bg-success"><td>A la carte VA :)</td></tr>
                    {% else %}
                        <tr class="bg-danger"><td>N'a pas la carte VA :/</td></tr>
                    {% endif %}

                    {% if object.profil_complete %}
                        <tr class="bg-success"><td>Profil complet :)</td></tr>
                    {% else %}
                        <tr class="bg-danger"><td>Profil incomplet :/</td></tr>
                    {% endif %}

                    {% if object.is_ma %}
                        <tr class="bg-success"><td>Est membre actif en ce moment :)</td></tr>
                    {% else %}
                        <tr class="bg-primary"><td>N'est pas membre actif en ce moment :/</td></tr>
                    {% endif %}
                </table>
            </div>
            <h3>Equipes du membre</h3>
            <div class="table-responsive">
                <table class="table">
                    <tr>
                        <th width="80%">Equipe</th>
                        <th>Page de l'équipe</th>
                    </tr>
                    {% for i in object.teams.all %}
                        <tr>
                            <td>{{ i.team.name }} - {{ i.name }}</td>
                        <td><a href="{% url "show_subteam" i.pk %}">Voir</a></td>
                        </tr>

                    {% endfor %}
                </table>
            </div>
        </div>

    </div>
{% endblock %}

active_members/templates/active_members/member_list.html
{% extends "base.html" %}
{% block content %}
    <div class="row"><a href="{% url "create_member" %}">
        <button type="button" class="btn btn-warning">Ajouter un MA</button>
    </a></div><br/>
    <div class="table-responsive">
        <table class="table">
            <tr>
                <th>Prénom</th>
                <th>Nom</th>
                <th>Age</th>
                <th>Email INSA</th>
                <th>Est MA</th>
                <th>Fiche</th>
            </tr>
            {% for member in object_list %}
                <tr {% if member.profil_complete %} style="background-color: aquamarine" {% endif %}>
                    <td>{{ member.first_name }}</td>
                    <td>{{ member.last_name }}</td>
                    <td {% if member.age  < 18 %}style="background-color: lightcoral" {% endif %}>{{ member.age }}
                        an{{ member.age|pluralize }}</td>
                    <td>{{ member.insa_email }}</td>
                    <td>{% if member.is_ma %} OUI {% else %} NON {% endif %}</td>
                    <td><a href="{% url "show_member" member.pk %}">Edit</a></td>
                </tr>
            {% endfor %}
        </table>
        {% if page_obj.has_other_pages %}
            <nav>
                <ul class="pagination">
                    {% if page_obj.has_previous %}
                        <li class="page-item"><a class="page-link" href="?page={{ page_obj.previous_page_number }}">&laquo;</a>
                        </li>
                    {% else %}
                        <a class="page-link" href="#" tabindex="-1">&laquo;</a>
                    {% endif %}
                    {% for i in page_obj.paginator.page_range %}
                        {% if page_obj.number == i %}
                            <li class="page-item active"><a class="page-link" href="#">{{ i }} <span class="sr-only">(current)</span></a>
                            </li>
                        {% else %}
                            <li class="page-item"><a class="page-link" href="?page={{ i }}">{{ i }}</a></li>
                        {% endif %}
                    {% endfor %}
                    {% if page_obj.has_next %}
                        <li class="page-item"><a class="page-link"
                                                 href="?page={{ page_obj.next_page_number }}">&raquo;</a></li>
                    {% else %}
                        <li class="page-item disabled"><a class="page-link" href="#" tabindex="-1">&raquo;</a></li>
                    {% endif %}
                </ul>
            </nav>
        {% endif %}
    </div>
{% endblock %}

active_members/templates/active_members/subteam_detail.html
{% extends "base.html" %}
{% block content %}
    <div class="row">
        <div class="col">
            <h1 class="">{{ object.team.name }} - {{ object.name }}</h1>
            <a href="{% url "show_team" object.team.pk %}"><button type="button" class="btn btn-primary">Voir équipe parente</button></a> <a href="{% url "edit_subteam" object.pk %}"><button type="button" class="btn btn-warning">Editer la sous équipe</button></a> <a href="{% url "edit_member_subteam" object.pk %}"><button type="button" class="btn btn-success">Ajouter un membre</button></a>
            <br>
        </div>
    </div>
  <br>
    <div class="row">
        <div class="col-sm-3">
            <!--left col-->
            <ul class="list-group">
                <li class="list-group-item text-muted" contenteditable="false">Détails</li>
                <li class="list-group-item text-right"><span class="pull-left"><strong class="">Responsable: </strong></span><br> {{ object.responsable }}</li>
                <li class="list-group-item text-right"><span class="pull-left"><strong class="">Mailing: </strong></span><br> {{ object.mailing }}</li>
                <li class="list-group-item text-right"><span class="pull-left"><strong class="">Effectif: </strong></span> {{ object.nombre }}</li>
            </ul><br/><br/>
            <div class="card text-white bg-danger mb-3" style="max-width: 18rem;">
                <div class="card-header">Zone dangeureuse</div>
                <div class="card-body" align="center">
                    <form method="get" action="{% url "clean_subteam" object.pk %}">
                        <button class="btn btn-secondary" onclick="return confirm('Etes vous sur ? Ceci est irréversible')">Vider la sous-équipe</button>
                    </form>
                </div>
            </div>
        </div>
        <!--/col-3-->
        <div class="col-sm-9" style="" contenteditable="false">
            <h3>Vérifications</h3>
            <div class="table-responsive">
                <table class="table">
                    {% if object.check_resp %}
                        <tr class="bg-success"><td>Définition du responsable OK</td></tr>
                    {% else %}
                        <tr class="bg-danger"><td>Problème dans le responsable</td></tr>
                    {% endif %}
                </table>
            </div>
            <h3>Membres</h3>
            <div class="table-responsive">
                <table class="table">
                    <tr>
                        <th width="80%">Membre</th>
                        <th>Supprimer</th>
                    </tr>
                    {% for i in object.members.all %}
                        <tr>
                            <td>{{ i.first_name }} {{ i.last_name }}</td>
                        <td><a href="{% url "delete_member_subteam" object.pk i.pk %}">Supprimer</a></td>
                        </tr>

                    {% endfor %}
                </table>
            </div>
        </div>

    </div>
{% endblock %}

active_members/templates/active_members/team_detail.html
{% extends "base.html" %}
{% block content %}
    <div class="row">
        <div class="col">
            <h1 class="">{{ object.name }}</h1>
            <a href="{% url "edit_team" object.pk %}"><button type="button" class="btn btn-warning">Editer l'équipe</button></a>
            <br>
        </div>
    </div>
  <br>
    <div class="row">
        <div class="col-sm-3">
            <!--left col-->
            <ul class="list-group">
                <li class="list-group-item text-muted" contenteditable="false">Détails</li>
                <li class="list-group-item text-right"><span class="pull-left"><strong class="">Type: </strong></span> {{ object.type }}</li>
                <li class="list-group-item text-right"><span class="pull-left"><strong class="">Responsable: </strong></span><br> {{ object.responsable }}</li>
                <li class="list-group-item text-right"><span class="pull-left"><strong class="">Mailing Resp: </strong></span><br> {{ object.resp_mailing }}</li>
                <li class="list-group-item text-right"><span class="pull-left"><strong class="">Effectif: </strong></span> {{ object.nombre }}</li>
            </ul><br>
            <div class="card text-white bg-danger mb-3" style="max-width: 18rem;">
                <div class="card-header">Zone dangeureuse</div>
                <div class="card-body" align="center">
                    <form method="get" action="{% url "clean_team" object.pk %}">
                        <button class="btn btn-secondary" onclick="return confirm('Etes vous sur ? Ceci est irréversible')">Vider la sous-équipe</button>
                    </form>
                </div>
            </div>
        </div>
        <!--/col-3-->
        <div class="col-sm-9" style="" contenteditable="false">
            <h3>Vérifications</h3>
            <div class="table-responsive">
                <table class="table">
                    {% if object.check_resp %}
                        <tr class="bg-success"><td>Définition du responsable OK</td></tr>
                    {% else %}
                        <tr class="bg-danger"><td>Problème dans le responsable</td></tr>
                    {% endif %}
                </table>
            </div>
            <h3>Sous-Equipes</h3>
            <div class="table-responsive">
                <table class="table">
                    <tr>
                        <th width="40%">Nom</th>
                        <th width="40%">Responsable</th>
                        <th>Effectif</th>
                        <th>Voir fiche</th>
                    </tr>
                    {% for i in object.subTeams.all %}
                        <tr {% if not i.check_resp%} style="background-color: lightcoral" {% endif %}>
                            <td>{{ i.name }}</td>
                            <td>{{ i.responsable }}</td>
                            <td>{{ i.nombre }}</td>
                            <td><a href="{% url "show_subteam" i.pk %}">Voir</a></td>
                        </tr>

                    {% endfor %}
                </table>
            </div>
            <h3>Membres</h3>
                        <div class="table_responsive">
                <table class="table">
                    <tr>
                        <th>Membre</th>
                        <th>Sous-Equipe</th>
                        <th>Voir fiche</th>
                    </tr>
            {% for i in object.subTeams.all %}
                    {% for j in i.members.all %}
                        <tr {% if not j.profil_complete%} style="background-color: lightcoral" {% endif %}>
                        <td>{{ j.first_name }} {{ j.last_name }}</td>
                        <td>{{ i.name }}</td>
                        <td><a href="{% url "show_member" j.pk %}">Voir</a></td>
                        </tr>
                    {% endfor %}

            {% endfor %}
                 </table>
                </div>
        </div>

    </div>
{% endblock %}

active_members/templates/active_members/team_list.html
{% extends "base.html" %}
{% block content %}
<div class="row">Aller dans l'admin pour ajouter une sous-equipe</div><br/>
<div class="table-responsive">
  <table class="table">
      <tr>
          <th>Nom</th>
          <th>Responsable</th>
          <th>Sous-Equipe</th>
          <th>Effectif</th>
          <th>Fiche</th>
      </tr>
      {% for team in object_list %}
          <tr {% if not team.check_all_ok%} style="background-color: lightcoral" {% endif %}>
              <td>{{ team.name }}</td>
              <td>{{ team.responsable }}</td>
              <td >{{ team.nombre_sous_equipe }}</td>
              <td >{{ team.nombre }}</td>
          <td><a href="{% url "show_team" team.pk %}">Edit</a></td>
          </tr>
      {% endfor %}
  </table>
</div>
{% endblock %}